/* mode 4 QL sprite picture driver */
/* copyright (c) W. lenerz 1996 */

#include "PFmodule.h"

/* declare external functions */

Error PFPictureElement(Gstate gstate, pt xsiz, pt ysiz, pt xorg, pt yorg);
Error SPRGetColour(int xpix,int ypix, short *add); /* gets colour for a pixel */
Error SprRec(char *base);

static Error Handle(int command,...)
{
	return ERR_NIMP;
}

static Error Recognize(Gstate gstate, char *base)
{
	return SprRec(base); /* call assembler function to recognize sprite */
}

static Error AspectRatio(Gstate gstate, char *base, int *xratio, int *yratio)
{
	Sprite *sprite=(Sprite *)(base+sizeof(FileInfo));
	*xratio=sprite->xsiz*3;
	*yratio=sprite->ysiz*2;
	return ERR_OK;
}

static Error ColourInfo(Gstate gstate, char *base, int *count, int *space)
{
	*count=4; /* there are 4 colours */
	*space=PF_COLOURSPACE_RGB;
	return ERR_OK;
}

static Error ColourGet(Gstate gstate, char *base, int which, void *colour)
{
	int err;
	ColourRGB *rgb=(ColourRGB *)colour;
	rgb->red=rgb->green=rgb->blue=pt_hundred;
	if (!(which&2))
		rgb->green	=0;
	if (!(which&1))
		rgb->red	=0;
	if (which!=3)
		rgb->blue	=0;
	return ERR_OK;
}

static Error Display(Gstate gstate, char *base, pt xsiz, pt ysiz,
							Error (*ColourSelect)(Gstate, int))
/* this displays the sprite */
{
	int xpixcount;			/* counter for x */
	int colour; 			/* colour */
	pt posy=0;				/* li */
	Sprite *sprite=(Sprite *)(base+sizeof(FileInfo));
	int xpix=sprite->xsiz;
	int ypix=sprite->ysiz;
	int line=0;

	xsiz/=xpix; 			/* make true sizes in pt */
	ysiz/=ypix;

	while(line != ypix) 	/* do it for all lines in sprite */
	{
		for(xpixcount=0; xpixcount!=xpix; xpixcount++)
		{
			colour=SPRGetColour(xpixcount, line, &sprite->form);

			/*
				 this function returns a colour for the pixel:
						 0 for black
						 1 for red
						 2 for green
						 3 for white
						 4 for transparent
			*/
			if (colour<4)
			{
				ColourSelect(gstate,colour);	/* set drawing colour now */
				PFPictureElement(gstate,xsiz,ysiz,xsiz*xpixcount,posy);
			}									/* draw one "pixel" */
		}
		posy+=ysiz;
		line++;
	}
	return ERR_OK;
}

PICTdriver init = {
	NULL, PF_PICTUREDRIVER,
	"QL Mode 4 Sprite Picture driver",
	Recognize,
	AspectRatio,
	Display,
	ColourInfo,
	ColourGet,
	Handle
};
